unit uBmkConvPlugin;
{
  BookmarkConverter pvOC̃ev[głD
}

interface


function ConvertFromXBEL(LoadFrom, SaveTo: PWideChar): PWideChar; stdcall;
function ConvertToXBEL(LoadFrom, SaveTo: PWideChar): PWideChar; stdcall;
function GetPluginInfo: PWideChar; stdcall;


implementation


uses
  {  }
  Windows,
  Classes;


//---------------------------------
{  GlobalAlloc |C^Ɋi[ĕԂ܂

  󂯎葤mɔjȂ΂Ȃ܂D

    GlobalFree(THandle(p));
}
function WideStringToAllocMem(const S: WideString): PWideChar;
var
  len: Integer;
begin
  if (S <> '') then
  begin
    len := (Length(S) * SizeOf(WideChar));
    Result := Pointer(GlobalAlloc(GPTR, (len + SizeOf(WideChar))));
    Move(PWideChar(S)^, Result^, len);
  end
  else
  begin
    Result := nil;
  end;
end;


//--------------------------------------------------------------------------------
{ XBEL ϊ }
function ConvertFromXBEL(LoadFrom, SaveTo: PWideChar): PWideChar; stdcall;
var
  i: Integer;
  tmptree: TBookmarkMenuTree;
  stream: TWideFileStream;
  files: TWideStringList;
  s: WideString;
  tmp: WideString;
begin
  tmptree := nil;
  files := TWideStringList.Create;
  try
    files.Text := LoadFrom;
    tmptree := TBookmarkMenuTree.Create;
    for i:=0 to files.Count-1 do
    begin
      if WideFileExists(files[i]) then
      begin
        tmptree.DeserializeFromFile(files[i]);
        s := SaveTo + WideChangeFileExt(WideExtractFileName(files[i]), '.htm');
        stream := TWideFileStream.Create(s, fmCreate);
        try

            // ***  stream ϊ ***

        finally
          stream.Free;
        end;
      end;
    end;

    tmp := '';
    Result := WideStringToAllocMem(tmp);
  finally
    tmptree.Free;
    files.Free;
  end;
end;


//--------------------------------------------------------------------------------
{ XBEL ֕ϊ

}
function ConvertToXBEL(LoadFrom, SaveTo: PWideChar): PWideChar; stdcall;
var
  i: Integer;
  tmptree: TBookmarkMenuTree;
  stream: TWideFileStream;
  files: TWideStringList;
  s: WideString;
  tmp: WideString;
begin
  tmptree := nil;
  files := TWideStringList.Create;
  try
    files.Text := LoadFrom;
    tmptree := TBookmarkMenuTree.Create;
    for i:=0 to files.Count-1 do
    begin
      if WideFileExists(files[i]) then
      begin
        tmptree.Clear;
        stream := TWideFileStream.Create(files[i], fmOpenRead);

          // ***  stream ϊ ***

        s := SaveTo + WideChangeFileExt(WideExtractFileName(files[i]), '.xml');
        tmptree.SerializeToFile(s);
      end;
    end;

    tmp := '';
    Result := WideStringToAllocMem(tmp);
  finally
    tmptree.Free;
    files.Free;
  end;
end;


//--------------------------------------------------------------------------------
{  }
function GetPluginInfo: PWideChar;
var
  s: WideString;
begin
  s := '???File(*.htm;*.html)|*.htm;*.html|All Files(*.*)|*.*'  + #13#10 +   // _CAÕtB^
       '.htm'                                                    + #13#10 +  // ftHggq
       ''                                                        + #13#10;   // ftHg̓͏ꏊ

  Result := WideStringToAllocMem(s);
end;

end.
